#!/usr/bin/plsperl
#############################################################################
##
##  Personal Library Software 3/14/95
##
##  This work is protected by US Copyright Law and contains proprietary and
##  confidential trade secrets.  PLS (c) Copyright 1995 by PLS,
##  All Rights Reserved
##
##  ### testweb.pl ###
##
##  Function:	Tests installation of PLWeb Turbo using testweb script 
##				included in the distribution
##
##
##  Created:    12/8/95		Tien Dinh 
##  
##  Changed:
##
##	Returns: 	1 if all tests are successful and 0 if not
##
##############################################################################

exit 1 unless (&testweb);

#########

sub testweb {

	## Get path ##

	$path = $0;
	if ($path ne "testweb.pl") {
		$path =~ s/testweb.pl//ig;
	}
	else {
		$path = "./";
	}

	#
	# Change directories to the test scripts dir
	#
	chdir ($path);

	#
	# Check to see if the test file exist
	#

	unless (-e "testweb.pl" ){
		print  "\nCouldn't locate the testscript, aborting\n\n";
		return 0;
	}
	
	$path = `pwd`;
		
	$binDir = $path;
	
	chop($binDir);

	$plwebDir = $binDir . "/..";

	$cgiDir = $binDir . "/../cgi-bin";

	# Set variable environment

	$ENV{'REQUEST_METHOD'} = "GET";
	$ENV{'PLWEB_ROOT'} = $plwebDir;

	#
	# Check to see if all directories exist
	#

	if (!-d $cgiDir){
		print "\nCannot find $cgiDir! Aborting and exiting.\n\n";
		return 0;
	}

	if (!-d $binDir){
		print "\nCannot find $tryDir! Aborting and exiting.\n\n";
		return 0;
	}

	#
	# Run test scripts 
	#
	
	$exec = "$cgiDir/fastweb";
	
	print "\nTesting PLWeb Turbo\n";
	
	if (!(-e $exec)){
		print "\nCannot find fastweb.\n\n";
		return 0;
	}

	$exec = $exec . " search simplesearch view1 Travel: 10 0 0 travel";

	#
	#  Redirect stdout and stderr into a temporary file 
	#
	system("$exec >output 2>&1");
	@err = `cat output`;
	$exec_error = "cannot";
	$fastweb_error = "Error";
	`rm -f output`;
	#
	# Check for error
	#
	for $line (@err){
		if (($line =~ /\b$exec_error\b/)||
		    ($line =~ /\b$fastweb_error\b/)){ 
			print "\nTest PLWeb Turbo failed.\n\n";
			
		        return 0 ;
		}
	}
	
	print "\nTest PLWeb Turbo passed\n\n";
	return 1;
}
